#include "HeXHubSDK.h"
#include "sysinfo.h"
#include <sstream>

extern Sysinfo sys;
extern float PercentCPU;

void Reparse(std::string &src) {
	std::stringstream esc;
	std::string::iterator it;

	for (it=src.begin(); it != src.end(); it++) {
		if ((unsigned char)*it == 0x0D) {
			esc << "<br>";
			continue;
		}
		if ((unsigned char)*it == 0x09) {
			esc<< "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			continue;
		}

		if (((unsigned char)*it >= 0x30) && ((unsigned char)*it <= 0x39) ||
			((unsigned char)*it >= 0x41) && ((unsigned char)*it <= 0x5A) ||
			((unsigned char)*it >= 0x61) && ((unsigned char)*it <= 0x7A)) {
				esc << *it;
		} else esc << "&#" << (int)((unsigned char)*it) << ";";
	}

	src = esc.str().c_str();
}

DWORD HEXHUBAPI HTTPEnumData(DWORD userId, const char *lpszPath, const char *lpszHost,
								  const char *lpszReferer, const char *lpszUserAgent, 
								  const char *lpszCookies, const char *lpszVariables, long enumerationIndex, 
								  const char *lpParameters, void *lpBuffer, long dataOffset)
{
	BOOL Continuation = false;
	if(dataOffset != 0) Continuation = true;
	//Time Values
	SYSTEMTIME st;
	GetLocalTime(&st);

	//Memory Values
	MEMORYSTATUS mstat;
	GlobalMemoryStatus(&mstat);

	//OS VALUES
	char OSName[256];
	sys.GetOSDisplayString(OSName);
	char Parameters[4096];
	char *inf = 0;
	std::stringstream main;

	SYSTEM_INFO si;
	GetSystemInfo(&si);
	SYSTEMTIME syst;
	GetSystemTime(&syst);

	memset(Parameters, 0, 4096);
	int i = 0;
	for (i=0; (i < 4095) && (lpParameters[i] != ']') && (lpParameters[i] != 0); i++) Parameters[i] = lpParameters[i];
	std::string copybuff;
	if(!Continuation)
	{
		for (i=0; Parameters[i] != 0; i++) {
			if (Parameters[i] == ' ') {
				copybuff = &Parameters[i+1];
				Parameters[i] = 0;
				break;
			}
		}
		if(strcmp(Parameters, "info") == 0)
		{
			if (enumerationIndex == 1) return -1;

			std::string::size_type sty;
			std::stringstream stream1;

			sty = copybuff.find("<APh>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwAvailPhys;
				copybuff.replace(sty, 5, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<APhMB>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwAvailPhys / 1024 / 1024;
				copybuff.replace(sty, 7, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<APhPct>", 0);
			if(sty != std::string::npos)
			{
				stream1 << sys.GetPercentage((float)mstat.dwAvailPhys, (float)mstat.dwTotalPhys);
				copybuff.replace(sty, 8, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<UPh>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalPhys - mstat.dwAvailPhys;
				copybuff.replace(sty, 5, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<UPhMB>", 0);
			if(sty != std::string::npos)
			{
				stream1 << (mstat.dwTotalPhys - mstat.dwAvailPhys) / 1024 / 1024;
				copybuff.replace(sty, 7, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<UPhPct>", 0);
			if(sty != std::string::npos)
			{
				stream1 << sys.GetPercentage((float)(mstat.dwTotalPhys - mstat.dwAvailPhys), (float)mstat.dwTotalPhys);
				copybuff.replace(sty, 8, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<TPh>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalPhys;
				copybuff.replace(sty, 5, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<TPhMB>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalPhys / 1024 / 1024;
				copybuff.replace(sty, 7, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<APF>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwAvailPageFile;
				copybuff.replace(sty, 5, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<APFMB>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwAvailPageFile / 1024 / 1024;
				copybuff.replace(sty, 7, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<APFPct>", 0);
			if(sty != std::string::npos)
			{
				stream1 << sys.GetPercentage((float)mstat.dwAvailPageFile, (float)mstat.dwTotalPageFile);
				copybuff.replace(sty, 8, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<UPF>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalPageFile - mstat.dwAvailPageFile;
				copybuff.replace(sty, 5, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<UPFMB>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalPageFile - mstat.dwAvailPageFile / 1024 / 1024;
				copybuff.replace(sty, 7, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<UPFPct>", 0);
			if(sty != std::string::npos)
			{
				stream1 << sys.GetPercentage((float)(mstat.dwTotalPageFile - mstat.dwAvailPageFile), (float)mstat.dwTotalPageFile);
				copybuff.replace(sty, 8, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<TPF>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalPageFile;
				copybuff.replace(sty, 5, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<TPFMB>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalPageFile / 1024 / 1024;
				copybuff.replace(sty, 7, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<AVM>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwAvailVirtual;
				copybuff.replace(sty, 5, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<AVMMB>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwAvailVirtual / 1024 / 1024;
				copybuff.replace(sty, 7, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<AVMPct>", 0);
			if(sty != std::string::npos)
			{
				stream1 << sys.GetPercentage((float)mstat.dwAvailVirtual, (float)mstat.dwTotalVirtual);
				copybuff.replace(sty, 8, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<UVM>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalVirtual - mstat.dwAvailVirtual;
				copybuff.replace(sty, 5, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<UVMMB>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalVirtual - mstat.dwAvailVirtual / 1024 / 1024;
				copybuff.replace(sty, 7, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<UVMPct>", 0);
			if(sty != std::string::npos)
			{
				stream1 << sys.GetPercentage((float)(mstat.dwTotalVirtual - mstat.dwAvailPageFile), (float)mstat.dwTotalVirtual);
				copybuff.replace(sty, 8, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<TVM>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalVirtual;
				copybuff.replace(sty, 5, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<TVMMB>", 0);
			if(sty != std::string::npos)
			{
				stream1 << mstat.dwTotalVirtual / 1024 / 1024;
				copybuff.replace(sty, 7, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<numcpus>", 0);
			if(sty != std::string::npos)
			{
				stream1 << si.dwNumberOfProcessors;
				copybuff.replace(sty, 9, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<cpuarc>", 0);
			if(sty != std::string::npos)
			{
				stream1 << si.dwProcessorType;
				copybuff.replace(sty, 8, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<cpupct>", 0);
			if(sty != std::string::npos)
			{
				stream1 << PercentCPU;
				copybuff.replace(sty, 8, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<cputime>", 0);
			if(sty != std::string::npos)
			{
				DWORD dwProcId = GetCurrentProcessId();
				HANDLE hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, NULL, dwProcId);
				FILETIME ftKernel;
				FILETIME ftUser;
				FILETIME ftCreation;
				FILETIME ftExit;
				SYSTEMTIME stKernel;
				GetProcessTimes(hProcess, &ftCreation, &ftExit, &ftKernel, &ftUser);
				FILETIME totalWorkTime;
				totalWorkTime.dwHighDateTime = ftKernel.dwHighDateTime + ftUser.dwHighDateTime;
				totalWorkTime.dwLowDateTime = ftKernel.dwLowDateTime + ftKernel.dwLowDateTime;
				FileTimeToSystemTime(&totalWorkTime, &stKernel);
				if(stKernel.wHour < 10) stream1 << "0";
				stream1 << stKernel.wHour << ":";
				if(stKernel.wMinute < 10) stream1 << "0";
				stream1 << stKernel.wMinute << ":";
				if(stKernel.wSecond < 10) stream1 << "0";
				stream1 << stKernel.wSecond;
				copybuff.replace(sty, 9, stream1.str().c_str());
				stream1.str("");
			}
			sty = copybuff.find("<cpuinfo>", 0);
			if(sty != std::string::npos)
			{
				if(si.dwNumberOfProcessors > 1)
				{
					int k = 0;
					for(k = 0; k < si.dwNumberOfProcessors; k++)
					{
						stream1 << "\r\n" << sys.GetCPUInfo(k);
					}
				}
				else 
				{
					stream1 << "\r\n" << sys.GetCPUInfo(0); 
				}
				std::string tmp;
				tmp = stream1.str();
				Reparse(tmp);
				copybuff.replace(sty, 9, tmp.c_str());
				stream1.str("");
			}
			sty = copybuff.find("<nicinfo>", 0);
			if(sty != std::string::npos)
			{
				stream1 << sys.GetNICInfo();
				std::string tmp;
				tmp = stream1.str();
				Reparse(tmp);
				copybuff.replace(sty, 9, tmp.c_str());
				stream1.str("");
			}
		}
	}
	else
	{
		copybuff = Parameters;
		if (enumerationIndex == 1) return -1;

		std::string::size_type sty;
		std::stringstream stream1;

		sty = copybuff.find("<APh>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwAvailPhys;
			copybuff.replace(sty, 5, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<APhMB>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwAvailPhys / 1024 / 1024;
			copybuff.replace(sty, 7, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<APhPct>", 0);
		if(sty != std::string::npos)
		{
			stream1 << sys.GetPercentage((float)mstat.dwAvailPhys, (float)mstat.dwTotalPhys);
			copybuff.replace(sty, 8, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<UPh>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalPhys - mstat.dwAvailPhys;
			copybuff.replace(sty, 5, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<UPhMB>", 0);
		if(sty != std::string::npos)
		{
			stream1 << (mstat.dwTotalPhys - mstat.dwAvailPhys) / 1024 / 1024;
			copybuff.replace(sty, 7, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<UPhPct>", 0);
		if(sty != std::string::npos)
		{
			stream1 << sys.GetPercentage((float)(mstat.dwTotalPhys - mstat.dwAvailPhys), (float)mstat.dwTotalPhys);
			copybuff.replace(sty, 8, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<TPh>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalPhys;
			copybuff.replace(sty, 5, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<TPhMB>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalPhys / 1024 / 1024;
			copybuff.replace(sty, 7, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<APF>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwAvailPageFile;
			copybuff.replace(sty, 5, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<APFMB>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwAvailPageFile / 1024 / 1024;
			copybuff.replace(sty, 7, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<APFPct>", 0);
		if(sty != std::string::npos)
		{
			stream1 << sys.GetPercentage((float)mstat.dwAvailPageFile, (float)mstat.dwTotalPageFile);
			copybuff.replace(sty, 8, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<UPF>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalPageFile - mstat.dwAvailPageFile;
			copybuff.replace(sty, 5, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<UPFMB>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalPageFile - mstat.dwAvailPageFile / 1024 / 1024;
			copybuff.replace(sty, 7, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<UPFPct>", 0);
		if(sty != std::string::npos)
		{
			stream1 << sys.GetPercentage((float)(mstat.dwTotalPageFile - mstat.dwAvailPageFile), (float)mstat.dwTotalPageFile);
			copybuff.replace(sty, 8, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<TPF>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalPageFile;
			copybuff.replace(sty, 5, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<TPFMB>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalPageFile / 1024 / 1024;
			copybuff.replace(sty, 7, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<AVM>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwAvailVirtual;
			copybuff.replace(sty, 5, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<AVMMB>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwAvailVirtual / 1024 / 1024;
			copybuff.replace(sty, 7, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<AVMPct>", 0);
		if(sty != std::string::npos)
		{
			stream1 << sys.GetPercentage((float)mstat.dwAvailVirtual, (float)mstat.dwTotalVirtual);
			copybuff.replace(sty, 8, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<UVM>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalVirtual - mstat.dwAvailVirtual;
			copybuff.replace(sty, 5, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<UVMMB>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalVirtual - mstat.dwAvailVirtual / 1024 / 1024;
			copybuff.replace(sty, 7, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<UVMPct>", 0);
		if(sty != std::string::npos)
		{
			stream1 << sys.GetPercentage((float)(mstat.dwTotalVirtual - mstat.dwAvailPageFile), (float)mstat.dwTotalVirtual);
			copybuff.replace(sty, 8, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<TVM>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalVirtual;
			copybuff.replace(sty, 5, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<TVMMB>", 0);
		if(sty != std::string::npos)
		{
			stream1 << mstat.dwTotalVirtual / 1024 / 1024;
			copybuff.replace(sty, 7, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<numcpus>", 0);
		if(sty != std::string::npos)
		{
			stream1 << si.dwNumberOfProcessors;
			copybuff.replace(sty, 9, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<cpuarc>", 0);
		if(sty != std::string::npos)
		{
			stream1 << si.dwProcessorType;
			copybuff.replace(sty, 8, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<cpupct>", 0);
		if(sty != std::string::npos)
		{
			stream1 << PercentCPU;
			copybuff.replace(sty, 8, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<cputime>", 0);
		if(sty != std::string::npos)
		{
			DWORD dwProcId = GetCurrentProcessId();
			HANDLE hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, NULL, dwProcId);
			FILETIME ftKernel;
			FILETIME ftUser;
			FILETIME ftCreation;
			FILETIME ftExit;
			SYSTEMTIME stKernel;
			GetProcessTimes(hProcess, &ftCreation, &ftExit, &ftKernel, &ftUser);
			FILETIME totalWorkTime;
			totalWorkTime.dwHighDateTime = ftKernel.dwHighDateTime + ftUser.dwHighDateTime;
			totalWorkTime.dwLowDateTime = ftKernel.dwLowDateTime + ftKernel.dwLowDateTime;
			FileTimeToSystemTime(&totalWorkTime, &stKernel);
			if(stKernel.wHour < 10) stream1 << "0";
			stream1 << stKernel.wHour << ":";
			if(stKernel.wMinute < 10) stream1 << "0";
			stream1 << stKernel.wMinute << ":";
			if(stKernel.wSecond < 10) stream1 << "0";
			stream1 << stKernel.wSecond;
			copybuff.replace(sty, 9, stream1.str().c_str());
			stream1.str("");
		}
		sty = copybuff.find("<cpuinfo>", 0);
		if(sty != std::string::npos)
		{
			if(si.dwNumberOfProcessors > 1)
			{
				int k = 0;
				for(k = 0; k < si.dwNumberOfProcessors; k++)
				{
					stream1 << "\r\n" << sys.GetCPUInfo(k);
				}
			}
			else 
			{
				stream1 << "\r\n" << sys.GetCPUInfo(0); 
			}
			std::string tmp;
			tmp = stream1.str();
			Reparse(tmp);
			copybuff.replace(sty, 9, tmp.c_str());
		}
		sty = copybuff.find("<nicinfo>", 0);
		if(sty != std::string::npos)
		{
			stream1 << sys.GetNICInfo();
			std::string tmp;
			tmp = stream1.str();
			Reparse(tmp);
			copybuff.replace(sty, 9, tmp.c_str());
			stream1.str("");
		}
	}
	std::string newdata;
	newdata = copybuff.substr(dataOffset, 4096);
	/*for(int l=dataOffset;(l<(dataOffset+4096)) && (copybuff[l] != 0);l++)
	{
			newdata.push_back(copybuff[l]);
	}*/
	int len = newdata.length();
	memset(lpBuffer, 0, 4096);
	memcpy(lpBuffer, newdata.c_str(), len);
	return len;
}